function s = default(arg1, arg2, arg3)
% function s = default(s, fieldname, defvalue)
% function default(varname,val)
%
% in two argument form, makes varname default to var in callers space
% in three argument form, 
%   for a structure s, make defvalue the default for
%   field fieldname

if (nargin == 2),
    varname = arg1;
    val = arg2;
    
    str = ['exist(''', varname, ''', ''var'')'];

    if ~(evalin('caller',str))
        assignin('caller',varname,val);
    else
        str = ['isempty(', varname ')'];
        if (evalin('caller',str))
            assignin('caller',varname,val);
        end
    end

end

if (nargin == 3),
    s = arg1;
    fieldname = arg2;
    defvalue = arg3;
    
    if (~isfield(s,fieldname))
        s = setfield(s,fieldname,defvalue);
    else
        if (isempty(getfield(s,fieldname)))
            s = setfield(s,fieldname,defvalue);
        end
    end

end
