function [v,a] = imgFlowSepMulti(img, pts0, pts1, a)
% function [v,a] = imgFlowSep3(img, pts0, pts1 , a)
%
% outputs a vector v of the flows, one for each point.
% generates a if it is not included as input
%
% generate a by:
% [a] = imgseg(img,support);
%
% Daniel A. Spielman, Yale University, Oct 3, 2006

pts0 = round(pts0);
pts1 = round(pts1);

if (nargin < 4),
  [a] = imgseg4(img,2);
end

s = sparse(sum(a));
d = diag(s);

l = d - a;

sz = size(img);

pts = [pts0; pts1];

st = zeros(sz(1)*sz(2),1);
st(pts0(:,1)*sz(1) + pts0(:,2)) = 1;
ind0 = find(st);

st = zeros(sz(1)*sz(2),1);
st(pts1(:,1)*sz(1) + pts1(:,2)) = 1;
ind1 = find(st);

ind = [ind0;ind1];

l(ind,:) = 0;
l(ind,ind) = speye(length(ind));


f = amdSolveF(l);

b = zeros(sz(1)*sz(2),1);
b(ind0) = 1;
v = f(b);


