function [st,sumwt,edgein,perm] = sparsecut(a,v,bal)
% function [st,sumwt,edgein,perm] = sparsecut(a,v,bal)
% 
% given an adj matrix a,
% and a vector v,
%
% order a by v,
% and return as a set the sparsest cut found.
%
% forcing balance bal

default('bal',.00001);

[vp,perm] = sort(v);
ap = a(perm,perm);

n = length(a);

sumwt = zeros(1,n);
edgein = zeros(1,n);

apu = triu(ap);

sumwt(1) = sum(ap(1,:));
for i = 2:n,
  sumwt(i) = sumwt(i-1) + sum(ap(:,i));
end

edgein = zeros(1,n);
for i = 2:n,
  edgein(i) = edgein(i-1) + sum(apu(:,i));
end


ratio = ((sumwt-2*edgein) ./ (sumwt .* (sumwt(end)-sumwt)));


[minv,ind] = min(ratio(ceil(n*bal):(n-floor(n*bal))));
vpbal = vp(ceil(n*bal):(n-floor(n*bal)));
cutval = vpbal(ind);

st = find(v <= cutval);

